---
title: "FreeBSD/ia64 5.1-RELEASE Release Notes"
sidenav: download
---

++++


        <h3 class="CORPAUTHOR">The FreeBSD Project</h3>

        <p class="COPYRIGHT">Copyright &copy; 2000, 2001, 2002,
        2003 by The FreeBSD Documentation Project</p>

        <p class="PUBDATE">$FreeBSD:
        src/release/doc/en_US.ISO8859-1/relnotes/common/new.sgml,v
        1.573 2003/05/28 21:01:22 hrs Exp $<br />
        </p>

        <div>
          <div class="ABSTRACT">
            <a id="AEN12" name="AEN12"></a>

            <p>The release notes for FreeBSD 5.1-RELEASE contain a
            summary of recent changes made to the FreeBSD base
            system on the 5-CURRENT development branch. This
            document lists applicable security advisories that were
            issued since the last release, as well as significant
            changes to the FreeBSD kernel and userland. Some brief
            remarks on upgrading are also presented.</p>
          </div>
        </div>
        <hr />
      </div>

      <div class="TOC">
        <dl>
          <dt><b>Table of Contents</b></dt>

          <dt>1 <a href="#INTRO">Introduction</a></dt>

          <dt>2 <a href="#NEW">What's New</a></dt>

          <dd>
            <dl>
              <dt>2.1 <a href="#SECURITY">Security
              Advisories</a></dt>

              <dt>2.2 <a href="#KERNEL">Kernel Changes</a></dt>

              <dd>
                <dl>
                  <dt>2.2.1 <a href="#PROC">Processor/Motherboard
                  Support</a></dt>

                  <dt>2.2.2 <a href="#BOOT">Boot Loader
                  Changes</a></dt>

                  <dt>2.2.3 <a href="#NET-IF">Network Interface
                  Support</a></dt>

                  <dt>2.2.4 <a href="#NET-PROTO">Network
                  Protocols</a></dt>

                  <dt>2.2.5 <a href="#DISKS">Disks and
                  Storage</a></dt>

                  <dt>2.2.6 <a href="#FS">File Systems</a></dt>

                  <dt>2.2.7 <a href="#PCCARD">PCCARD
                  Support</a></dt>

                  <dt>2.2.8 <a href="#MM">Multimedia
                  Support</a></dt>
                </dl>
              </dd>

              <dt>2.3 <a href="#USERLAND">Userland Changes</a></dt>

              <dt>2.4 <a href="#CONTRIB">Contributed
              Software</a></dt>

              <dt>2.5 <a href="#PORTS">Ports/Packages Collection
              Infrastructure</a></dt>

              <dt>2.6 <a href="#RELENG">Release Engineering and
              Integration</a></dt>

              <dt>2.7 <a href="#DOC">Documentation</a></dt>
            </dl>
          </dd>

          <dt>3 <a href="#UPGRADE">Upgrading from previous releases
          of FreeBSD</a></dt>
        </dl>
      </div>

      <div class="SECT1">
        <hr />

        <h1 class="SECT1"><a id="INTRO" name="INTRO">1
        Introduction</a></h1>

        <p>This document contains the release notes for FreeBSD
        5.1-RELEASE on the IA-64 hardware platform. It describes
        recently added, changed, or deleted features of FreeBSD. It
        also provides some notes on upgrading from previous
        versions of FreeBSD.</p>

        <p>This distribution of FreeBSD 5.1-RELEASE is a release
        distribution. It can be found at <a
        href="ftp://ftp.FreeBSD.org/"
        target="_top">ftp://ftp.FreeBSD.org/</a> or any of its
        mirrors. More information on obtaining this (or other)
        release distributions of FreeBSD can be found in the <a
        href="http://www.FreeBSD.org/doc/en_US.ISO8859-1/books/handbook/mirrors.html"
         target="_top">``Obtaining FreeBSD'' appendix</a> to the <a
        href="http://www.FreeBSD.org/doc/en_US.ISO8859-1/books/handbook/"
         target="_top">FreeBSD Handbook</a>.</p>

        <p>Users who are new to the 5-CURRENT series of FreeBSD
        releases should also read the ``Early Adopters Guide to
        FreeBSD 5.1-RELEASE''. This document can generally be found
        in the same location as the release notes (either as a part
        of a FreeBSD distribution or on the FreeBSD Web site). It
        contains important information regarding the advantages and
        disadvantages of using FreeBSD 5.1-RELEASE, as opposed to
        releases based on the FreeBSD 4-STABLE development
        branch.</p>

        <p>All users are encouraged to consult the release errata
        before installing FreeBSD. The errata document is updated
        with ``late-breaking'' information discovered late in the
        release cycle or after the release. Typically, it contains
        information on known bugs, security advisories, and
        corrections to documentation. An up-to-date copy of the
        errata for FreeBSD 5.1-RELEASE can be found on the FreeBSD
        Web site.</p>
      </div>

      <div class="SECT1">
        <hr />

        <h1 class="SECT1"><a id="NEW" name="NEW">2 What's
        New</a></h1>

        <p>This section describes many of the user-visible new or
        changed features in FreeBSD since 5.0-RELEASE. It includes
        items that are unique to the 5-CURRENT branch, as well as
        some features that may have been recently merged to other
        branches (after FreeBSD 5.0-RELEASE). The latter items are
        marked as [MERGED].</p>

        <p>Typical release note items document recent security
        advisories issued after 5.0-RELEASE, new drivers or
        hardware support, new commands or options, major bug fixes,
        or contributed software upgrades. They may also list
        changes to major ports/packages or release engineering
        practices. Clearly the release notes cannot list every
        single change made to FreeBSD between releases; this
        document focuses primarily on security advisories,
        user-visible changes, and major architectural
        improvements.</p>

        <div class="SECT2">
          <hr />

          <h2 class="SECT2"><a id="SECURITY" name="SECURITY">2.1
          Security Advisories</a></h2>

          <p>A remotely exploitable vulnerability in <b
          class="APPLICATION">CVS</b> has been corrected with the
          import of version 1.11.5. More details can be found in
          security advisory <a
          href="ftp://ftp.FreeBSD.org/pub/FreeBSD/CERT/advisories/FreeBSD-SA-03:01.cvs.asc"
           target="_top">FreeBSD-SA-03:01</a>. [MERGED]</p>

          <p>A timing-based attack on <b
          class="APPLICATION">OpenSSL</b>, which could allow a very
          powerful attacker access to plaintext under certain
          circumstances, has been prevented via an upgrade to <b
          class="APPLICATION">OpenSSL</b> 0.9.7. See security
          advisory <a
          href="ftp://ftp.FreeBSD.org/pub/FreeBSD/CERT/advisories/FreeBSD-SA-03:02.openssl.asc"
           target="_top">FreeBSD-SA-03:02</a> for more details.
          [MERGED]</p>

          <p>The security and performance of the ``syncookies''
          feature has been improved to decrease the chance of an
          attacker being able to spoof connections. More details
          are given in security advisory <a
          href="ftp://ftp.FreeBSD.org/pub/FreeBSD/CERT/advisories/FreeBSD-SA-03:03.syncookies.asc"
           target="_top">FreeBSD-SA-03:03</a>. [MERGED]</p>

          <p>Remotely-exploitable buffer overflow vulnerabilities
          in <b class="APPLICATION">sendmail</b> have been fixed by
          updating <b class="APPLICATION">sendmail</b>. For more
          details, see security advisory <a
          href="ftp://ftp.FreeBSD.org/pub/FreeBSD/CERT/advisories/FreeBSD-SA-03:04.sendmail.asc"
           target="_top">FreeBSD-SA-03:04</a> and <a
          href="ftp://ftp.FreeBSD.org/pub/FreeBSD/CERT/advisories/FreeBSD-SA-03:07.sendmail.asc"
           target="_top">FreeBSD-SA-03:07</a>. [MERGED]</p>

          <p>A bounds-checking bug in the XDR implementation, which
          could allow a remote attacker to cause a
          denial-of-service, has been fixed. For more details see
          security advisory <a
          href="ftp://ftp.FreeBSD.org/pub/FreeBSD/CERT/advisories/FreeBSD-SA-03:05.xdr.asc"
           target="_top">FreeBSD-SA-03:05</a>. [MERGED]</p>

          <p>Two recently-publicized flaws in <b
          class="APPLICATION">OpenSSL</b> have been corrected. For
          more details, see security advisory <a
          href="ftp://ftp.FreeBSD.org/pub/FreeBSD/CERT/advisories/FreeBSD-SA-03:06.openssl.asc"
           target="_top">FreeBSD-SA-03:06</a>. [MERGED]</p>
        </div>

        <div class="SECT2">
          <hr />

          <h2 class="SECT2"><a id="KERNEL" name="KERNEL">2.2 Kernel
          Changes</a></h2>

          <p><a
          href="http://www.FreeBSD.org/cgi/man.cgi?query=devfs&amp;sektion=5&amp;manpath=FreeBSD+5.1-release">
          <span class="CITEREFENTRY"><span
          class="REFENTRYTITLE">devfs</span>(5)</span></a> is now
          mandatory; the <tt class="LITERAL">NODEVFS</tt> option
          has been removed from the set of possible kernel
          configuration options.</p>

          <p>An <a
          href="http://www.FreeBSD.org/cgi/man.cgi?query=ehci&amp;sektion=4&amp;manpath=FreeBSD+5.1-release">
          <span class="CITEREFENTRY"><span
          class="REFENTRYTITLE">ehci</span>(4)</span></a> driver
          has been added; it supports the USB Enhanced Host
          Controller Interface used by USB 2.0 controllers.</p>

          <p>A minor bug in the permissions handling of <tt
          class="FILENAME">/dev/tty</tt> has been fixed. As a
          result, <a
          href="http://www.FreeBSD.org/cgi/man.cgi?query=ssh&amp;sektion=1&amp;manpath=FreeBSD+5.1-release">
          <span class="CITEREFENTRY"><span
          class="REFENTRYTITLE">ssh</span>(1)</span></a> can now be
          used after <a
          href="http://www.FreeBSD.org/cgi/man.cgi?query=su&amp;sektion=1&amp;manpath=FreeBSD+5.1-release">
          <span class="CITEREFENTRY"><span
          class="REFENTRYTITLE">su</span>(1)</span></a>.</p>

          <p>A bug that caused <a
          href="http://www.FreeBSD.org/cgi/man.cgi?query=fstat&amp;sektion=2&amp;manpath=FreeBSD+5.1-release">
          <span class="CITEREFENTRY"><span
          class="REFENTRYTITLE">fstat</span>(2)</span></a> to
          return <tt class="LITERAL">0</tt> as the number of bytes
          available to read from a TCP socket has been fixed.</p>

          <p>A bug that caused <a
          href="http://www.FreeBSD.org/cgi/man.cgi?query=kqueue&amp;sektion=2&amp;manpath=FreeBSD+5.1-release">
          <span class="CITEREFENTRY"><span
          class="REFENTRYTITLE">kqueue</span>(2)</span></a> to
          report <tt class="LITERAL">0</tt> as the number of bytes
          available to read from a TCP socket has been fixed. The
          <tt class="LITERAL">NOTE_LOWAT</tt> flag for <tt
          class="LITERAL">EVFILT_READ</tt> has been fixed.</p>

          <p>Linux emulation mode now supports IPv6.</p>

          <p><a
          href="http://www.FreeBSD.org/cgi/man.cgi?query=madvise&amp;sektion=2&amp;manpath=FreeBSD+5.1-release">
          <span class="CITEREFENTRY"><span
          class="REFENTRYTITLE">madvise</span>(2)</span></a> now
          supports a <tt class="LITERAL">MADV_PROTECT</tt>
          behavior, which informs the virtual memory system that a
          process is critical and should not be killed when swap
          space has been exhausted. The process must be owned by
          the superuser.</p>

          <p>A second process scheduler, designed to be a general
          purpose scheduler with many SMP benefits, has been added
          to the scheduler framework. Exactly one scheduler must be
          specified in a kernel configuration. The original
          scheduler may be selected using <tt
          class="LITERAL">options&nbsp;SCHED_4BSD</tt>. The newer
          (experimental) scheduler can be selected by using <tt
          class="LITERAL">options&nbsp;SCHED_ULE</tt>.</p>

          <p>Device major numbers are now allocated dynamically by
          default. This change greatly decreases the need for a
          static, centralized table of major number assignments to
          device drivers (a few drivers retain their old static
          major numbers for compatibility), and also reduces the
          possibility of running out of device major numbers.</p>

          <div class="SECT3">
            <hr />

            <h3 class="SECT3"><a id="PROC" name="PROC">2.2.1
            Processor/Motherboard Support</a></h3>
          </div>

          <div class="SECT3">
            <hr />

            <h3 class="SECT3"><a id="BOOT" name="BOOT">2.2.2 Boot
            Loader Changes</a></h3>

            <p>The <tt class="FILENAME">/modules</tt> directory
            (once the default location for modules on FreeBSD 4.<tt
            class="REPLACEABLE"><i>X</i></tt>) is no longer a part
            of the default <tt
            class="VARNAME">kern.module_path</tt>. Third-party
            modules should be placed in <tt
            class="FILENAME">/boot/modules</tt>.</p>

            <div class="NOTE">
              <blockquote class="NOTE">
                <p><b>Note:</b> Modules designed for use with
                FreeBSD 4.<tt class="REPLACEABLE"><i>X</i></tt> are
                likely to panic when loaded into a FreeBSD
                5.1-RELEASE kernel and should be used with extreme
                caution.</p>
              </blockquote>
            </div>
            <br />
            <br />
          </div>

          <div class="SECT3">
            <hr />

            <h3 class="SECT3"><a id="NET-IF" name="NET-IF">2.2.3
            Network Interface Support</a></h3>

            <p>The cm driver now supports IPX. [MERGED]</p>

            <p>A new <a
            href="http://www.FreeBSD.org/cgi/man.cgi?query=wlan&amp;sektion=4&amp;manpath=FreeBSD+5.1-release">
            <span class="CITEREFENTRY"><span
            class="REFENTRYTITLE">wlan</span>(4)</span></a> module
            provides 802.11 link-layer support. The <a
            href="http://www.FreeBSD.org/cgi/man.cgi?query=wi&amp;sektion=4&amp;manpath=FreeBSD+5.1-release">
            <span class="CITEREFENTRY"><span
            class="REFENTRYTITLE">wi</span>(4)</span></a> and <a
            href="http://www.FreeBSD.org/cgi/man.cgi?query=an&amp;sektion=4&amp;manpath=FreeBSD+5.1-release">
            <span class="CITEREFENTRY"><span
            class="REFENTRYTITLE">an</span>(4)</span></a> drivers
            now use this facility.</p>
          </div>

          <div class="SECT3">
            <hr />

            <h3 class="SECT3"><a id="NET-PROTO"
            name="NET-PROTO">2.2.4 Network Protocols</a></h3>

            <p><a
            href="http://www.FreeBSD.org/cgi/man.cgi?query=ipfw&amp;sektion=4&amp;manpath=FreeBSD+5.1-release">
            <span class="CITEREFENTRY"><span
            class="REFENTRYTITLE">ipfw</span>(4)</span></a> <tt
            class="LITERAL">skipto</tt> rules can once again be
            used with the <tt class="LITERAL">log</tt> keyword. <a
            href="http://www.FreeBSD.org/cgi/man.cgi?query=ipfw&amp;sektion=4&amp;manpath=FreeBSD+5.1-release">
            <span class="CITEREFENTRY"><span
            class="REFENTRYTITLE">ipfw</span>(4)</span></a> <tt
            class="LITERAL">uid</tt> rules are once again
            working.</p>

            <p>It is now possible to build the <tt
            class="LITERAL">FAST_IPSEC</tt> and <tt
            class="LITERAL">INET6</tt> options into the same
            kernel. (They still cannot be used together,
            however.)</p>

            <p>A bug in TCP NewReno, which caused premature exit
            from fast recovery when NewReno was enabled, has been
            fixed. [MERGED]</p>

            <p>TCP now has support for the ``Limited Transmit''
            mechanism proposed by RFC 3042. This feature is
            intended to improve the effectiveness of TCP loss
            recovery in certain circumstances. It is off by default
            but can be enabled with the <tt
            class="VARNAME">net.inet.tcp.rfc3042</tt> sysctl
            variable. More information can be found in <a
            href="http://www.FreeBSD.org/cgi/man.cgi?query=tcp&amp;sektion=4&amp;manpath=FreeBSD+5.1-release">
            <span class="CITEREFENTRY"><span
            class="REFENTRYTITLE">tcp</span>(4)</span></a>.</p>

            <p>TCP now has support for increased initial congestion
            window sizes as described in RFC 3390. This feature can
            improve the throughput of short transfers, as well as
            high-bandwidth, large propagation-delay connections. It
            is off by default but can be enabled with the <tt
            class="VARNAME">net.inet.tcp.rfc3390</tt> sysctl
            variable. More information can be found in <a
            href="http://www.FreeBSD.org/cgi/man.cgi?query=tcp&amp;sektion=4&amp;manpath=FreeBSD+5.1-release">
            <span class="CITEREFENTRY"><span
            class="REFENTRYTITLE">tcp</span>(4)</span></a>.</p>

            <p>The IP fragment reassembly code behaves more
            gracefully when receiving a large number of packet
            fragments (it is designed to be more resistant to
            fragment-based denial of service attacks). [MERGED]</p>

            <p>TCP connections in the <tt
            class="LITERAL">TIME_WAIT</tt> state now use a special
            protocol control block that uses less space than a
            full-blown TCP PCB. This allows some of the data
            structures and resources used by such a connection to
            be freed earlier.</p>

            <p>It is now possible to specify the range of
            ``privileged ports'' (TCP and UDP ports that require
            superuser access to <a
            href="http://www.FreeBSD.org/cgi/man.cgi?query=bind&amp;sektion=2&amp;manpath=FreeBSD+5.1-release">
            <span class="CITEREFENTRY"><span
            class="REFENTRYTITLE">bind</span>(2)</span></a> to).
            The range is now specified with the <tt
            class="VARNAME">net.inet.ip.portrange.reservedlow</tt>
            and <tt
            class="VARNAME">net.inet.ip.portrange.reservedhigh</tt>
            sysctl variables, defaulting to the traditional UNIX
            behavior. This feature is intended to help network
            servers bind to traditionally privileged ports without
            requiring superuser access. <a
            href="http://www.FreeBSD.org/cgi/man.cgi?query=ip&amp;sektion=4&amp;manpath=FreeBSD+5.1-release">
            <span class="CITEREFENTRY"><span
            class="REFENTRYTITLE">ip</span>(4)</span></a> has more
            details.</p>

            <p>Some bugs in the non-blocking RPC code has been
            fixed. As a result, <a
            href="http://www.FreeBSD.org/cgi/man.cgi?query=amd&amp;sektion=8&amp;manpath=FreeBSD+5.1-release">
            <span class="CITEREFENTRY"><span
            class="REFENTRYTITLE">amd</span>(8)</span></a> users
            are now able to mount volumes from a 5.1-RELEASE
            server.</p>

            <p>Support for XNS networking, which has not worked
            correctly for almost seven years, has been removed.</p>
          </div>

          <div class="SECT3">
            <hr />

            <h3 class="SECT3"><a id="DISKS" name="DISKS">2.2.5
            Disks and Storage</a></h3>

            <p>The <a
            href="http://www.FreeBSD.org/cgi/man.cgi?query=aac&amp;sektion=4&amp;manpath=FreeBSD+5.1-release">
            <span class="CITEREFENTRY"><span
            class="REFENTRYTITLE">aac</span>(4)</span></a> driver
            now runs free of the Giant kernel lock. This change has
            given a nearly 20% performance speedup on an SMP system
            running multiple I/O intensive loads.</p>

            <p>The <a
            href="http://www.FreeBSD.org/cgi/man.cgi?query=ata&amp;sektion=4&amp;manpath=FreeBSD+5.1-release">
            <span class="CITEREFENTRY"><span
            class="REFENTRYTITLE">ata</span>(4)</span></a> driver
            now supports all known SiS chipsets. (More details can
            be found in the Hardware Notes.)</p>

            <p>The <a
            href="http://www.FreeBSD.org/cgi/man.cgi?query=ata&amp;sektion=4&amp;manpath=FreeBSD+5.1-release">
            <span class="CITEREFENTRY"><span
            class="REFENTRYTITLE">ata</span>(4)</span></a> driver
            now supports the Promise SATA150 TX2 and TX4 Serial
            ATA/150 controllers.</p>

            <p>The <a
            href="http://www.FreeBSD.org/cgi/man.cgi?query=ata&amp;sektion=4&amp;manpath=FreeBSD+5.1-release">
            <span class="CITEREFENTRY"><span
            class="REFENTRYTITLE">ata</span>(4)</span></a> driver
            now flushes devices on shutdown. This change may result
            in failure messages being printed on the console for
            devices that do not support flushing.</p>

            <p>The CAM layer now has support for devices with more
            than 2<sup>32</sup> blocks. (Assuming 512-byte blocks,
            this means support for devices larger than 2TB.)</p>

            <div class="NOTE">
              <blockquote class="NOTE">
                <p><b>Note:</b> For users upgrading across this
                change, note that all userland applications that
                talk to <a
                href="http://www.FreeBSD.org/cgi/man.cgi?query=pass&amp;sektion=4&amp;manpath=FreeBSD+5.1-release">
                <span class="CITEREFENTRY"><span
                class="REFENTRYTITLE">pass</span>(4)</span></a> or
                <a
                href="http://www.FreeBSD.org/cgi/man.cgi?query=xpt&amp;sektion=4&amp;manpath=FreeBSD+5.1-release">
                <span class="CITEREFENTRY"><span
                class="REFENTRYTITLE">xpt</span>(4)</span></a>
                devices must be recompiled. Examples of such
                programs are <a
                href="http://www.FreeBSD.org/cgi/man.cgi?query=camcontrol&amp;sektion=8&amp;manpath=FreeBSD+5.1-release">
                <span class="CITEREFENTRY"><span
                class="REFENTRYTITLE">camcontrol</span>(8)</span></a>
                in the base system, the <tt
                class="FILENAME">sysutils/cdrtools</tt> port, and
                the <tt class="FILENAME">multimedia/xmms</tt>
                port.</p>
              </blockquote>
            </div>
            <br />
            <br />

            <p>A number of changes have been made to the <a
            href="http://www.FreeBSD.org/cgi/man.cgi?query=cd&amp;sektion=4&amp;manpath=FreeBSD+5.1-release">
            <span class="CITEREFENTRY"><span
            class="REFENTRYTITLE">cd</span>(4)</span></a> driver.
            The primary user-visible change is improved
            compatibility with ATAPI/USB/Firewire CDROM drives.</p>

            <p><a
            href="http://www.FreeBSD.org/cgi/man.cgi?query=geom&amp;sektion=4&amp;manpath=FreeBSD+5.1-release">
            <span class="CITEREFENTRY"><span
            class="REFENTRYTITLE">geom</span>(4)</span></a> is now
            mandatory; the <tt class="LITERAL">NO_GEOM</tt> has
            been removed from the set of kernel configuration
            options.</p>

            <p>The <a
            href="http://www.FreeBSD.org/cgi/man.cgi?query=iir&amp;sektion=4&amp;manpath=FreeBSD+5.1-release">
            <span class="CITEREFENTRY"><span
            class="REFENTRYTITLE">iir</span>(4)</span></a> driver
            has been updated; this update is believed to fix
            problems detecting attached disks during
            installation.</p>

            <p>A bug in the <a
            href="http://www.FreeBSD.org/cgi/man.cgi?query=mly&amp;sektion=4&amp;manpath=FreeBSD+5.1-release">
            <span class="CITEREFENTRY"><span
            class="REFENTRYTITLE">mly</span>(4)</span></a> driver
            that caused hangs has been corrected.</p>

            <p>Support has been added for volume labels on UFS and
            UFS2 file systems. These labels are strings that can be
            used to identify a volume, regardless of what device it
            appears on. Labels can be set with the <tt
            class="OPTION">-L</tt> options to <a
            href="http://www.FreeBSD.org/cgi/man.cgi?query=newfs&amp;sektion=8&amp;manpath=FreeBSD+5.1-release">
            <span class="CITEREFENTRY"><span
            class="REFENTRYTITLE">newfs</span>(8)</span></a> or <a
            href="http://www.FreeBSD.org/cgi/man.cgi?query=tunefs&amp;sektion=8&amp;manpath=FreeBSD+5.1-release">
            <span class="CITEREFENTRY"><span
            class="REFENTRYTITLE">tunefs</span>(8)</span></a>. With
            the <tt class="LITERAL">GEOM_VOL</tt> module, volumes
            can be accessed using their labels under <tt
            class="FILENAME">/dev/vol</tt>.</p>

            <p>The root file system can now be located on a <a
            href="http://www.FreeBSD.org/cgi/man.cgi?query=vinum&amp;sektion=4&amp;manpath=FreeBSD+5.1-release">
            <span class="CITEREFENTRY"><span
            class="REFENTRYTITLE">vinum</span>(4)</span></a>
            volume. More information can be found in the <a
            href="http://www.FreeBSD.org/cgi/man.cgi?query=vinum&amp;sektion=4&amp;manpath=FreeBSD+5.1-release">
            <span class="CITEREFENTRY"><span
            class="REFENTRYTITLE">vinum</span>(4)</span></a> manual
            page.</p>
          </div>

          <div class="SECT3">
            <hr />

            <h3 class="SECT3"><a id="FS" name="FS">2.2.6 File
            Systems</a></h3>

            <p>A new <tt class="LITERAL">DIRECTIO</tt> kernel
            option enables support for read operations that bypass
            the buffer cache and put data directly into a userland
            buffer. This feature requires that the <tt
            class="LITERAL">O_DIRECT</tt> flag is set on the file
            descriptor and that both the offset and length for the
            read operation are multiples of the physical media
            sector size. [MERGED]</p>

            <p>NETNCP and Netware File System Support (nwfs) are
            once again working.</p>

            <p>Bugs that could cause the unmounting of a smbfs
            share to fail or cause a kernel panic have been
            fixed.</p>
          </div>

          <div class="SECT3">
            <hr />

            <h3 class="SECT3"><a id="PCCARD" name="PCCARD">2.2.7
            PCCARD Support</a></h3>
          </div>

          <div class="SECT3">
            <hr />

            <h3 class="SECT3"><a id="MM" name="MM">2.2.8 Multimedia
            Support</a></h3>
          </div>
        </div>

        <div class="SECT2">
          <hr />

          <h2 class="SECT2"><a id="USERLAND" name="USERLAND">2.3
          Userland Changes</a></h2>

          <p><a
          href="http://www.FreeBSD.org/cgi/man.cgi?query=adduser&amp;sektion=8&amp;manpath=FreeBSD+5.1-release">
          <span class="CITEREFENTRY"><span
          class="REFENTRYTITLE">adduser</span>(8)</span></a> now
          correctly handles setting user passwords containing
          special shell characters.</p>

          <p><a
          href="http://www.FreeBSD.org/cgi/man.cgi?query=adduser&amp;sektion=8&amp;manpath=FreeBSD+5.1-release">
          <span class="CITEREFENTRY"><span
          class="REFENTRYTITLE">adduser</span>(8)</span></a> now
          supports a <tt class="OPTION">-g</tt> option to set a
          user's default login group.</p>

          <p>The <a
          href="http://www.FreeBSD.org/cgi/man.cgi?query=bsdlabel&amp;sektion=8&amp;manpath=FreeBSD+5.1-release">
          <span class="CITEREFENTRY"><span
          class="REFENTRYTITLE">bsdlabel</span>(8)</span></a>
          utility is a replacement for the older disklabel utility.
          Like its predecessor, it installs, examines, or modifies
          the BSD label on a disk partition, and can install
          bootstrap code. Compared to disklabel, a number of
          obsolete options and parameters have been retired. A new
          <tt class="OPTION">-m</tt> option instructs <a
          href="http://www.FreeBSD.org/cgi/man.cgi?query=bsdlabel&amp;sektion=8&amp;manpath=FreeBSD+5.1-release">
          <span class="CITEREFENTRY"><span
          class="REFENTRYTITLE">bsdlabel</span>(8)</span></a> to
          use the layout suitable for a specific machine.</p>

          <p><a
          href="http://www.FreeBSD.org/cgi/man.cgi?query=chgrp&amp;sektion=1&amp;manpath=FreeBSD+5.1-release">
          <span class="CITEREFENTRY"><span
          class="REFENTRYTITLE">chgrp</span>(1)</span></a> and <a
          href="http://www.FreeBSD.org/cgi/man.cgi?query=chown&amp;sektion=8&amp;manpath=FreeBSD+5.1-release">
          <span class="CITEREFENTRY"><span
          class="REFENTRYTITLE">chown</span>(8)</span></a> now,
          when the owner/group is modified, print the old and new
          uid/gid if the <tt class="OPTION">-v</tt> option is
          specified more than once.</p>

          <p><a
          href="http://www.FreeBSD.org/cgi/man.cgi?query=config&amp;sektion=8&amp;manpath=FreeBSD+5.1-release">
          <span class="CITEREFENTRY"><span
          class="REFENTRYTITLE">config</span>(8)</span></a> now
          implements a <tt class="LITERAL">nodevice</tt> kernel
          configuration file directive that cancels the effect of a
          <tt class="LITERAL">device</tt> directive. The new <tt
          class="LITERAL">nooption</tt> and <tt
          class="LITERAL">nomakeoption</tt> directives cancel prior
          <tt class="LITERAL">options</tt> and <tt
          class="LITERAL">makeoptions</tt> directives,
          respectively.</p>

          <p>The <a
          href="http://www.FreeBSD.org/cgi/man.cgi?query=diskinfo&amp;sektion=8&amp;manpath=FreeBSD+5.1-release">
          <span class="CITEREFENTRY"><span
          class="REFENTRYTITLE">diskinfo</span>(8)</span></a>
          utility has been added to show information about a disk
          device and optionally to run a naive performance
          test.</p>

          <p>The disklabel utility has been replaced by <a
          href="http://www.FreeBSD.org/cgi/man.cgi?query=bsdlabel&amp;sektion=8&amp;manpath=FreeBSD+5.1-release">
          <span class="CITEREFENTRY"><span
          class="REFENTRYTITLE">bsdlabel</span>(8)</span></a>. On
          the alpha, i386, and pc98 platforms, disklabel is a link
          to <a
          href="http://www.FreeBSD.org/cgi/man.cgi?query=bsdlabel&amp;sektion=8&amp;manpath=FreeBSD+5.1-release">
          <span class="CITEREFENTRY"><span
          class="REFENTRYTITLE">bsdlabel</span>(8)</span></a>.</p>

          <p><a
          href="http://www.FreeBSD.org/cgi/man.cgi?query=dump&amp;sektion=8&amp;manpath=FreeBSD+5.1-release">
          <span class="CITEREFENTRY"><span
          class="REFENTRYTITLE">dump</span>(8)</span></a> now
          supports caching of disk blocks with the <tt
          class="OPTION">-C</tt> option. This can improve dump
          performance at the cost of possibly missing file system
          updates that occur between passes.</p>

          <p><a
          href="http://www.FreeBSD.org/cgi/man.cgi?query=dumpfs&amp;sektion=8&amp;manpath=FreeBSD+5.1-release">
          <span class="CITEREFENTRY"><span
          class="REFENTRYTITLE">dumpfs</span>(8)</span></a> now
          supports a <tt class="OPTION">-m</tt> flag to print file
          system parameters in the form of a <a
          href="http://www.FreeBSD.org/cgi/man.cgi?query=newfs&amp;sektion=8&amp;manpath=FreeBSD+5.1-release">
          <span class="CITEREFENTRY"><span
          class="REFENTRYTITLE">newfs</span>(8)</span></a>
          command.</p>

          <p><a
          href="http://www.FreeBSD.org/cgi/man.cgi?query=elfdump&amp;sektion=1&amp;manpath=FreeBSD+5.1-release">
          <span class="CITEREFENTRY"><span
          class="REFENTRYTITLE">elfdump</span>(1)</span></a>, a
          utility to display information about <a
          href="http://www.FreeBSD.org/cgi/man.cgi?query=elf&amp;sektion=5&amp;manpath=FreeBSD+5.1-release">
          <span class="CITEREFENTRY"><span
          class="REFENTRYTITLE">elf</span>(5)</span></a> format
          executable files, has been added.</p>

          <p><a
          href="http://www.FreeBSD.org/cgi/man.cgi?query=fetch&amp;sektion=1&amp;manpath=FreeBSD+5.1-release">
          <span class="CITEREFENTRY"><span
          class="REFENTRYTITLE">fetch</span>(1)</span></a> uses the
          <tt class="FILENAME">.netrc</tt> support in <a
          href="http://www.FreeBSD.org/cgi/man.cgi?query=fetch&amp;sektion=3&amp;manpath=FreeBSD+5.1-release">
          <span class="CITEREFENTRY"><span
          class="REFENTRYTITLE">fetch</span>(3)</span></a> and also
          supports a <tt class="OPTION">-N</tt> to specify an
          alternate <tt class="FILENAME">.netrc</tt> file.</p>

          <p><a
          href="http://www.FreeBSD.org/cgi/man.cgi?query=fetch&amp;sektion=3&amp;manpath=FreeBSD+5.1-release">
          <span class="CITEREFENTRY"><span
          class="REFENTRYTITLE">fetch</span>(3)</span></a> now has
          support for <tt class="FILENAME">.netrc</tt> files (see
          <a
          href="http://www.FreeBSD.org/cgi/man.cgi?query=ftp&amp;sektion=1&amp;manpath=FreeBSD+5.1-release">
          <span class="CITEREFENTRY"><span
          class="REFENTRYTITLE">ftp</span>(1)</span></a> for more
          details).</p>

          <p><a
          href="http://www.FreeBSD.org/cgi/man.cgi?query=ftpd&amp;sektion=8&amp;manpath=FreeBSD+5.1-release">
          <span class="CITEREFENTRY"><span
          class="REFENTRYTITLE">ftpd</span>(8)</span></a> now
          supports a <tt class="OPTION">-h</tt> option to disable
          printing any host-specific information, such as the <a
          href="http://www.FreeBSD.org/cgi/man.cgi?query=ftpd&amp;sektion=8&amp;manpath=FreeBSD+5.1-release">
          <span class="CITEREFENTRY"><span
          class="REFENTRYTITLE">ftpd</span>(8)</span></a> version
          or hostname, in server messages. [MERGED]</p>

          <p><a
          href="http://www.FreeBSD.org/cgi/man.cgi?query=ftpd&amp;sektion=8&amp;manpath=FreeBSD+5.1-release">
          <span class="CITEREFENTRY"><span
          class="REFENTRYTITLE">ftpd</span>(8)</span></a> now
          supports a <tt class="OPTION">-P</tt> option to specify a
          port on which to listen in daemon mode. The default data
          port number is now set to be one less than the control
          port number, rather than being hard-coded. [MERGED]</p>

          <p><a
          href="http://www.FreeBSD.org/cgi/man.cgi?query=ftpd&amp;sektion=8&amp;manpath=FreeBSD+5.1-release">
          <span class="CITEREFENTRY"><span
          class="REFENTRYTITLE">ftpd</span>(8)</span></a> now
          supports an extended format of the <tt
          class="FILENAME">/etc/ftpchroot</tt> file. Please refer
          to the <a
          href="http://www.FreeBSD.org/cgi/man.cgi?query=ftpchroot&amp;sektion=5&amp;manpath=FreeBSD+5.1-release">
          <span class="CITEREFENTRY"><span
          class="REFENTRYTITLE">ftpchroot</span>(5)</span></a>
          manpage, which is now available, for details.
          [MERGED]</p>

          <p><a
          href="http://www.FreeBSD.org/cgi/man.cgi?query=ftpd&amp;sektion=8&amp;manpath=FreeBSD+5.1-release">
          <span class="CITEREFENTRY"><span
          class="REFENTRYTITLE">ftpd</span>(8)</span></a> now
          supports login directory pathnames that specify
          simultaneously a directory for <a
          href="http://www.FreeBSD.org/cgi/man.cgi?query=chroot&amp;sektion=2&amp;manpath=FreeBSD+5.1-release">
          <span class="CITEREFENTRY"><span
          class="REFENTRYTITLE">chroot</span>(2)</span></a> and
          that to change to in the chrooted environment. The <tt
          class="LITERAL">/./</tt> separator is used for this
          purpose, like in other FTP daemons having this feature.
          It may be used in both <a
          href="http://www.FreeBSD.org/cgi/man.cgi?query=ftpchroot&amp;sektion=5&amp;manpath=FreeBSD+5.1-release">
          <span class="CITEREFENTRY"><span
          class="REFENTRYTITLE">ftpchroot</span>(5)</span></a> and
          <a
          href="http://www.FreeBSD.org/cgi/man.cgi?query=passwd&amp;sektion=5&amp;manpath=FreeBSD+5.1-release">
          <span class="CITEREFENTRY"><span
          class="REFENTRYTITLE">passwd</span>(5)</span></a>.
          [MERGED]</p>

          <p><a
          href="http://www.FreeBSD.org/cgi/man.cgi?query=fwcontrol&amp;sektion=8&amp;manpath=FreeBSD+5.1-release">
          <span class="CITEREFENTRY"><span
          class="REFENTRYTITLE">fwcontrol</span>(8)</span></a> now
          supports <tt class="OPTION">-R</tt> and <tt
          class="OPTION">-S</tt> options for receiving and sending
          DV streams. [MERGED]</p>

          <p>The <a
          href="http://www.FreeBSD.org/cgi/man.cgi?query=gstat&amp;sektion=8&amp;manpath=FreeBSD+5.1-release">
          <span class="CITEREFENTRY"><span
          class="REFENTRYTITLE">gstat</span>(8)</span></a> utility
          has been added to show the disk activity inside the <a
          href="http://www.FreeBSD.org/cgi/man.cgi?query=geom&amp;sektion=4&amp;manpath=FreeBSD+5.1-release">
          <span class="CITEREFENTRY"><span
          class="REFENTRYTITLE">geom</span>(4)</span></a>
          subsystem.</p>

          <p><a
          href="http://www.FreeBSD.org/cgi/man.cgi?query=ipfw&amp;sektion=8&amp;manpath=FreeBSD+5.1-release">
          <span class="CITEREFENTRY"><span
          class="REFENTRYTITLE">ipfw</span>(8)</span></a> now
          supports <tt class="LITERAL">enable</tt> and <tt
          class="LITERAL">disable</tt> commands to control various
          aspects of the operation of <a
          href="http://www.FreeBSD.org/cgi/man.cgi?query=ipfw&amp;sektion=4&amp;manpath=FreeBSD+5.1-release">
          <span class="CITEREFENTRY"><span
          class="REFENTRYTITLE">ipfw</span>(4)</span></a>
          (including enabling and disabling the firewall itself).
          These provide a more convenient and visible interface
          than the existing sysctl variables. [MERGED]</p>

          <p><a
          href="http://www.FreeBSD.org/cgi/man.cgi?query=jail&amp;sektion=8&amp;manpath=FreeBSD+5.1-release">
          <span class="CITEREFENTRY"><span
          class="REFENTRYTITLE">jail</span>(8)</span></a> now
          supports a <tt class="OPTION">-i</tt> flag to output an
          identifier for a newly-created jail.</p>

          <p>The <a
          href="http://www.FreeBSD.org/cgi/man.cgi?query=jexec&amp;sektion=8&amp;manpath=FreeBSD+5.1-release">
          <span class="CITEREFENTRY"><span
          class="REFENTRYTITLE">jexec</span>(8)</span></a> utility
          has been added to execute a command inside an existing
          jail.</p>

          <p>The <a
          href="http://www.FreeBSD.org/cgi/man.cgi?query=jls&amp;sektion=8&amp;manpath=FreeBSD+5.1-release">
          <span class="CITEREFENTRY"><span
          class="REFENTRYTITLE">jls</span>(8)</span></a> utility
          has been added to list existing jails.</p>

          <p><a
          href="http://www.FreeBSD.org/cgi/man.cgi?query=kenv&amp;sektion=1&amp;manpath=FreeBSD+5.1-release">
          <span class="CITEREFENTRY"><span
          class="REFENTRYTITLE">kenv</span>(1)</span></a> has been
          moved from <tt class="FILENAME">/usr/bin</tt> to <tt
          class="FILENAME">/bin</tt> to make it available at times
          during system startup when only the root file system is
          mounted.</p>

          <p><a
          href="http://www.FreeBSD.org/cgi/man.cgi?query=killall&amp;sektion=1&amp;manpath=FreeBSD+5.1-release">
          <span class="CITEREFENTRY"><span
          class="REFENTRYTITLE">killall</span>(1)</span></a> now
          supports a <tt class="OPTION">-j</tt> option to kill all
          processes inside a jail.</p>

          <p>The <a
          href="http://www.FreeBSD.org/cgi/man.cgi?query=libgeom&amp;sektion=3&amp;manpath=FreeBSD+5.1-release">
          <span class="CITEREFENTRY"><span
          class="REFENTRYTITLE">libgeom</span>(3)</span></a>
          library has been added to allow some userland access to
          the <a
          href="http://www.FreeBSD.org/cgi/man.cgi?query=geom&amp;sektion=4&amp;manpath=FreeBSD+5.1-release">
          <span class="CITEREFENTRY"><span
          class="REFENTRYTITLE">geom</span>(4)</span></a>
          subsystem.</p>

          <p>The mac_portacl MAC policy module has been added. It
          provides a simple ACL mechanism to permit users and
          groups to bind ports for TCP or UDP, and is intended to
          be used in conjunction with the recently-added <tt
          class="VARNAME">net.inet.ip.portrange.reservedhigh</tt>
          sysctl.</p>

          <p>The <tt class="FILENAME">MAKEDEV</tt> script is now
          unnecessary, due to the mandatory presence of <a
          href="http://www.FreeBSD.org/cgi/man.cgi?query=devfs&amp;sektion=5&amp;manpath=FreeBSD+5.1-release">
          <span class="CITEREFENTRY"><span
          class="REFENTRYTITLE">devfs</span>(5)</span></a>, and has
          been removed.</p>

          <p><a
          href="http://www.FreeBSD.org/cgi/man.cgi?query=mergemaster&amp;sektion=8&amp;manpath=FreeBSD+5.1-release">
          <span class="CITEREFENTRY"><span
          class="REFENTRYTITLE">mergemaster</span>(8)</span></a>
          now supports a <tt class="OPTION">-P</tt> option to
          preserve the contents of files being replaced.</p>

          <p><a
          href="http://www.FreeBSD.org/cgi/man.cgi?query=mixer&amp;sektion=8&amp;manpath=FreeBSD+5.1-release">
          <span class="CITEREFENTRY"><span
          class="REFENTRYTITLE">mixer</span>(8)</span></a> can now
          implement relative volume adjustments.</p>

          <p>The <a
          href="http://www.FreeBSD.org/cgi/man.cgi?query=mksnap_ffs&amp;sektion=8&amp;manpath=FreeBSD+5.1-release">
          <span class="CITEREFENTRY"><span
          class="REFENTRYTITLE">mksnap_ffs</span>(8)</span></a>
          program has been added to allow easier creation of FFS
          snapshots. It is a SUID-<tt class="USERNAME">root</tt>
          executable designed for use by members of the <tt
          class="GROUPNAME">operator</tt> group.</p>

          <p><a
          href="http://www.FreeBSD.org/cgi/man.cgi?query=mount&amp;sektion=8&amp;manpath=FreeBSD+5.1-release">
          <span class="CITEREFENTRY"><span
          class="REFENTRYTITLE">mount</span>(8)</span></a> and <a
          href="http://www.FreeBSD.org/cgi/man.cgi?query=umount&amp;sektion=8&amp;manpath=FreeBSD+5.1-release">
          <span class="CITEREFENTRY"><span
          class="REFENTRYTITLE">umount</span>(8)</span></a> now
          accept a <tt class="OPTION">-F</tt> option to specify an
          alternate <a
          href="http://www.FreeBSD.org/cgi/man.cgi?query=fstab&amp;sektion=5&amp;manpath=FreeBSD+5.1-release">
          <span class="CITEREFENTRY"><span
          class="REFENTRYTITLE">fstab</span>(5)</span></a>
          file.</p>

          <p><a
          href="http://www.FreeBSD.org/cgi/man.cgi?query=mount_nfs&amp;sektion=8&amp;manpath=FreeBSD+5.1-release">
          <span class="CITEREFENTRY"><span
          class="REFENTRYTITLE">mount_nfs</span>(8)</span></a> now
          supports a <tt class="OPTION">-c</tt> flag to avoid doing
          a <a
          href="http://www.FreeBSD.org/cgi/man.cgi?query=connect&amp;sektion=2&amp;manpath=FreeBSD+5.1-release">
          <span class="CITEREFENTRY"><span
          class="REFENTRYTITLE">connect</span>(2)</span></a> for
          UDP mount points. This option must be used if the server
          does not reply to requests from the standard NFS port
          number 2049 or if it replies to requests using a
          different IP address (which can occur if the server is
          multi-homed). Setting the <tt
          class="VARNAME">vfs.nfs.nfs_ip_paranoia</tt> sysctl to
          <tt class="LITERAL">0</tt> will make this option the
          default. [MERGED]</p>

          <p><a
          href="http://www.FreeBSD.org/cgi/man.cgi?query=mount_nfs&amp;sektion=8&amp;manpath=FreeBSD+5.1-release">
          <span class="CITEREFENTRY"><span
          class="REFENTRYTITLE">mount_nfs</span>(8)</span></a> now
          supports the <tt class="OPTION">noinet4</tt> and <tt
          class="OPTION">noinet6</tt> mount options to prevent NFS
          mounts from using IPv4 or IPv6 respectively.</p>

          <p><a
          href="http://www.FreeBSD.org/cgi/man.cgi?query=newfs&amp;sektion=8&amp;manpath=FreeBSD+5.1-release">
          <span class="CITEREFENTRY"><span
          class="REFENTRYTITLE">newfs</span>(8)</span></a> will now
          create UFS2 file systems by default, unless UFS1 is
          specifically requested with the <tt
          class="OPTION">-O1</tt> option.</p>

          <p><a
          href="http://www.FreeBSD.org/cgi/man.cgi?query=newsyslog&amp;sektion=8&amp;manpath=FreeBSD+5.1-release">
          <span class="CITEREFENTRY"><span
          class="REFENTRYTITLE">newsyslog</span>(8)</span></a> has
          a number of new features. Among them:</p>

          <ul>
            <li>
              <p>A <tt class="LITERAL">W</tt> flag forces
              previously-started compression jobs for an entry (or
              group of entries specified with the <tt
              class="LITERAL">G</tt> flag) to finish before
              beginning a new one. This feature is designed to
              prevent system overloads caused by starting several
              compression jobs on big files simultaneously.
              [MERGED]</p>
            </li>

            <li>
              <p>A ``default rotate action'', to be used for files
              specified for rotation but not specified in the
              configuration file. [MERGED]</p>
            </li>

            <li>
              <p>A <tt class="OPTION">-s</tt> command-line flag to
              disable sending signals to processes when rotating
              files. [MERGED]</p>
            </li>

            <li>
              <p>A <tt class="LITERAL">N</tt> configuration file
              flag to indicate that no process needs to be signaled
              when rotating a file. [MERGED]</p>
            </li>

            <li>
              <p>A <tt class="LITERAL">U</tt> configuration file
              flag to specify that a process group (rather than a
              single process) should be signaled when rotating
              files. [MERGED]</p>
            </li>
          </ul>
          <br />
          <br />

          <p><a
          href="http://www.FreeBSD.org/cgi/man.cgi?query=nsdispatch&amp;sektion=3&amp;manpath=FreeBSD+5.1-release">
          <span class="CITEREFENTRY"><span
          class="REFENTRYTITLE">nsdispatch</span>(3)</span></a> is
          now thread-safe and implements support for Name Service
          Switch (NSS) modules. NSS modules may be statically built
          into <tt class="FILENAME">libc</tt> or dynamically loaded
          via <a
          href="http://www.FreeBSD.org/cgi/man.cgi?query=dlopen&amp;sektion=3&amp;manpath=FreeBSD+5.1-release">
          <span class="CITEREFENTRY"><span
          class="REFENTRYTITLE">dlopen</span>(3)</span></a>. They
          are loaded/initialized at configuration time (i.e. when
          <a
          href="http://www.FreeBSD.org/cgi/man.cgi?query=nsdispatch&amp;sektion=3&amp;manpath=FreeBSD+5.1-release">
          <span class="CITEREFENTRY"><span
          class="REFENTRYTITLE">nsdispatch</span>(3)</span></a> is
          called and <a
          href="http://www.FreeBSD.org/cgi/man.cgi?query=nsswitch.conf&amp;sektion=5&amp;manpath=FreeBSD+5.1-release">
          <span class="CITEREFENTRY"><span
          class="REFENTRYTITLE">nsswitch.conf</span>(5)</span></a>
          is read or re-read).</p>

          <p>A new <a
          href="http://www.FreeBSD.org/cgi/man.cgi?query=pam_chroot&amp;sektion=8&amp;manpath=FreeBSD+5.1-release">
          <span class="CITEREFENTRY"><span
          class="REFENTRYTITLE">pam_chroot</span>(8)</span></a>
          module has been added, which does a <a
          href="http://www.FreeBSD.org/cgi/man.cgi?query=chroot&amp;sektion=2&amp;manpath=FreeBSD+5.1-release">
          <span class="CITEREFENTRY"><span
          class="REFENTRYTITLE">chroot</span>(2)</span></a>
          operation for users into either a predetermined directory
          or one derived from their home directory.</p>

          <p><a
          href="http://www.FreeBSD.org/cgi/man.cgi?query=pam_ssh&amp;sektion=8&amp;manpath=FreeBSD+5.1-release">
          <span class="CITEREFENTRY"><span
          class="REFENTRYTITLE">pam_ssh</span>(8)</span></a> has
          been rewritten. One side effect of the rewrite is that it
          now starts a separate instance of <a
          href="http://www.FreeBSD.org/cgi/man.cgi?query=ssh-agent&amp;sektion=1&amp;manpath=FreeBSD+5.1-release">
          <span class="CITEREFENTRY"><span
          class="REFENTRYTITLE">ssh-agent</span>(1)</span></a> for
          each session instead of trying to connect each session to
          the agent started by the first session.</p>

          <p><a
          href="http://www.FreeBSD.org/cgi/man.cgi?query=ping&amp;sektion=8&amp;manpath=FreeBSD+5.1-release">
          <span class="CITEREFENTRY"><span
          class="REFENTRYTITLE">ping</span>(8)</span></a> now
          supports a <tt class="OPTION">-D</tt> flag to set the
          ``Don't Fragment'' bit on outgoing packets.</p>

          <p><a
          href="http://www.FreeBSD.org/cgi/man.cgi?query=ping&amp;sektion=8&amp;manpath=FreeBSD+5.1-release">
          <span class="CITEREFENTRY"><span
          class="REFENTRYTITLE">ping</span>(8)</span></a> now
          supports a <tt class="OPTION">-M</tt> option to use ICMP
          mask request or timestamp request messages instead of
          ICMP echo requests.</p>

          <p><a
          href="http://www.FreeBSD.org/cgi/man.cgi?query=ping&amp;sektion=8&amp;manpath=FreeBSD+5.1-release">
          <span class="CITEREFENTRY"><span
          class="REFENTRYTITLE">ping</span>(8)</span></a> now
          supports a <tt class="OPTION">-z</tt> flag to set the
          Type of Service bits in outgoing packets.</p>

          <p><a
          href="http://www.FreeBSD.org/cgi/man.cgi?query=pw&amp;sektion=8&amp;manpath=FreeBSD+5.1-release">
          <span class="CITEREFENTRY"><span
          class="REFENTRYTITLE">pw</span>(8)</span></a> can now add
          a user whose name ends with a <tt class="LITERAL">$</tt>
          character; this change is intended to help administration
          of <b class="APPLICATION">Samba</b> services.
          [MERGED]</p>

          <p>The format of the <tt
          class="FILENAME">/etc/pwd.db</tt> and <tt
          class="FILENAME">/etc/spwd.db</tt> password databases
          created by <a
          href="http://www.FreeBSD.org/cgi/man.cgi?query=pwd_mkdb&amp;sektion=8&amp;manpath=FreeBSD+5.1-release">
          <span class="CITEREFENTRY"><span
          class="REFENTRYTITLE">pwd_mkdb</span>(8)</span></a> is
          now byte-order independent. The pre-processed password
          databases can now be moved between machines of different
          architectures. The format includes version numbers on
          entries to ensure compatibility with old binaries.</p>

          <p>A bug in <a
          href="http://www.FreeBSD.org/cgi/man.cgi?query=rand&amp;sektion=3&amp;manpath=FreeBSD+5.1-release">
          <span class="CITEREFENTRY"><span
          class="REFENTRYTITLE">rand</span>(3)</span></a> that
          could cause a sequence to remain stuck at <tt
          class="LITERAL">0</tt> has been fixed. (<a
          href="http://www.FreeBSD.org/cgi/man.cgi?query=rand&amp;sektion=3&amp;manpath=FreeBSD+5.1-release">
          <span class="CITEREFENTRY"><span
          class="REFENTRYTITLE">rand</span>(3)</span></a> remains
          unsuitable for all but trivial uses.)</p>

          <p><a
          href="http://www.FreeBSD.org/cgi/man.cgi?query=rtld&amp;sektion=1&amp;manpath=FreeBSD+5.1-release">
          <span class="CITEREFENTRY"><span
          class="REFENTRYTITLE">rtld</span>(1)</span></a> now has
          support for the dynamic mapping of shared object
          dependencies. This optional feature is especially useful
          when experimenting with different threading libraries. It
          is not, however, built by default. More information on
          enabling and using this feature can be found in <a
          href="http://www.FreeBSD.org/cgi/man.cgi?query=libmap.conf&amp;sektion=5&amp;manpath=FreeBSD+5.1-release">
          <span class="CITEREFENTRY"><span
          class="REFENTRYTITLE">libmap.conf</span>(5)</span></a>.</p>

          <p><a
          href="http://www.FreeBSD.org/cgi/man.cgi?query=sem_open&amp;sektion=3&amp;manpath=FreeBSD+5.1-release">
          <span class="CITEREFENTRY"><span
          class="REFENTRYTITLE">sem_open</span>(3)</span></a> now
          correctly handles multiple opens of the same semaphore;
          as a result, <a
          href="http://www.FreeBSD.org/cgi/man.cgi?query=sem_close&amp;sektion=3&amp;manpath=FreeBSD+5.1-release">
          <span class="CITEREFENTRY"><span
          class="REFENTRYTITLE">sem_close</span>(3)</span></a> no
          longer crashes calling programs.</p>

          <p>The seeding algorithm used by <a
          href="http://www.FreeBSD.org/cgi/man.cgi?query=srandom&amp;sektion=3&amp;manpath=FreeBSD+5.1-release">
          <span class="CITEREFENTRY"><span
          class="REFENTRYTITLE">srandom</span>(3)</span></a> has
          been strengthened.</p>

          <p><a
          href="http://www.FreeBSD.org/cgi/man.cgi?query=sysinstall&amp;sektion=8&amp;manpath=FreeBSD+5.1-release">
          <span class="CITEREFENTRY"><span
          class="REFENTRYTITLE">sysinstall</span>(8)</span></a>
          will now select UFS2 as the default layout for new file
          systems unless specifically requested in the disk
          labeler.</p>

          <p>The <a
          href="http://www.FreeBSD.org/cgi/man.cgi?query=swapoff&amp;sektion=8&amp;manpath=FreeBSD+5.1-release">
          <span class="CITEREFENTRY"><span
          class="REFENTRYTITLE">swapoff</span>(8)</span></a>
          command has been added to disable paging and swapping on
          a device. A related <a
          href="http://www.FreeBSD.org/cgi/man.cgi?query=swapctl&amp;sektion=8&amp;manpath=FreeBSD+5.1-release">
          <span class="CITEREFENTRY"><span
          class="REFENTRYTITLE">swapctl</span>(8)</span></a>
          command has been added to provide an interface to <a
          href="http://www.FreeBSD.org/cgi/man.cgi?query=swapon&amp;sektion=8&amp;manpath=FreeBSD+5.1-release">
          <span class="CITEREFENTRY"><span
          class="REFENTRYTITLE">swapon</span>(8)</span></a> and <a
          href="http://www.FreeBSD.org/cgi/man.cgi?query=swapoff&amp;sektion=8&amp;manpath=FreeBSD+5.1-release">
          <span class="CITEREFENTRY"><span
          class="REFENTRYTITLE">swapoff</span>(8)</span></a>
          similar to other BSDs.</p>

          <div class="NOTE">
            <blockquote class="NOTE">
              <p><b>Note:</b> The <a
              href="http://www.FreeBSD.org/cgi/man.cgi?query=swapoff&amp;sektion=8&amp;manpath=FreeBSD+5.1-release">
              <span class="CITEREFENTRY"><span
              class="REFENTRYTITLE">swapoff</span>(8)</span></a>
              feature should be considered experimental.</p>
            </blockquote>
          </div>
          <br />
          <br />

          <p><a
          href="http://www.FreeBSD.org/cgi/man.cgi?query=syslogd&amp;sektion=8&amp;manpath=FreeBSD+5.1-release">
          <span class="CITEREFENTRY"><span
          class="REFENTRYTITLE">syslogd</span>(8)</span></a> now
          allows multiple hosts or programs to be named in host or
          program specifications in <a
          href="http://www.FreeBSD.org/cgi/man.cgi?query=syslog.conf&amp;sektion=5&amp;manpath=FreeBSD+5.1-release">
          <span class="CITEREFENTRY"><span
          class="REFENTRYTITLE">syslog.conf</span>(5)</span></a>
          files.</p>

          <p><a
          href="http://www.FreeBSD.org/cgi/man.cgi?query=systat&amp;sektion=1&amp;manpath=FreeBSD+5.1-release">
          <span class="CITEREFENTRY"><span
          class="REFENTRYTITLE">systat</span>(1)</span></a> now
          includes an <tt class="OPTION">-ifstat</tt> display mode
          that displays the network traffic going through active
          interfaces on the system.</p>

          <p>The <a
          href="http://www.FreeBSD.org/cgi/man.cgi?query=usbhidaction&amp;sektion=1&amp;manpath=FreeBSD+5.1-release">
          <span class="CITEREFENTRY"><span
          class="REFENTRYTITLE">usbhidaction</span>(1)</span></a>
          command has been added; it performs actions according to
          its configuration in response to USB HID controls.</p>

          <p><a
          href="http://www.FreeBSD.org/cgi/man.cgi?query=uudecode&amp;sektion=1&amp;manpath=FreeBSD+5.1-release">
          <span class="CITEREFENTRY"><span
          class="REFENTRYTITLE">uudecode</span>(1)</span></a> and
          <a
          href="http://www.FreeBSD.org/cgi/man.cgi?query=b64decode&amp;sektion=1&amp;manpath=FreeBSD+5.1-release">
          <span class="CITEREFENTRY"><span
          class="REFENTRYTITLE">b64decode</span>(1)</span></a> now
          support a <tt class="OPTION">-r</tt> flag for decoding
          raw (or broken) files that may be missing the initial and
          possibly final framing lines. [MERGED]</p>

          <p><a
          href="http://www.FreeBSD.org/cgi/man.cgi?query=vmstat&amp;sektion=8&amp;manpath=FreeBSD+5.1-release">
          <span class="CITEREFENTRY"><span
          class="REFENTRYTITLE">vmstat</span>(8)</span></a> has
          re-implemented the <tt class="OPTION">-f</tt> flag, which
          displays statistics on fork operations.</p>

          <p><a
          href="http://www.FreeBSD.org/cgi/man.cgi?query=xargs&amp;sektion=1&amp;manpath=FreeBSD+5.1-release">
          <span class="CITEREFENTRY"><span
          class="REFENTRYTITLE">xargs</span>(1)</span></a> now
          supports a <tt class="OPTION">-P</tt> option to execute
          multiple copies of the same utility in parallel.</p>

          <p><a
          href="http://www.FreeBSD.org/cgi/man.cgi?query=xargs&amp;sektion=1&amp;manpath=FreeBSD+5.1-release">
          <span class="CITEREFENTRY"><span
          class="REFENTRYTITLE">xargs</span>(1)</span></a> now
          supports a <tt class="OPTION">-o</tt> flag to reopen <tt
          class="FILENAME">/dev/tty</tt> for the child process
          before executing the command. This is useful when the
          child process is an interactive application.</p>

          <p>A 1:1 threading package (where for every pthread in an
          application there is one KSE and thread) has been
          implemented. Under this model, the kernel handles all
          thread scheduling decisions and all signal delivery. This
          uses some of the common KSE code, and is a restricted
          case of the M:N threading work still in progress. The <tt
          class="FILENAME">libthr</tt> library implementing the
          userland portion of this functionality is a drop-in
          replacement for the <tt class="FILENAME">libc_r</tt>
          library. Note that <tt class="FILENAME">libthr</tt> is
          not (at this time) built by default.</p>

          <p>The historic BSD boot scripts in <tt
          class="FILENAME">/etc</tt> have been removed, in favor of
          the <tt class="FILENAME">rc.d</tt> system imported from
          <b class="APPLICATION">NetBSD</b> (sometimes referred to
          as ``rcNG''). All functionality of the historic system
          has been preserved. In particular, files such as <tt
          class="FILENAME">/etc/rc.conf</tt> continue to be the
          recommended means of configuring the system startup. The
          <tt class="FILENAME">rc.d</tt> system has been the
          default since FreeBSD 5.0-RELEASE, so this change should
          be largely transparent for the vast majority of users.
          Users who have customized their historic-style startup
          scripts should be aware that the following files have
          been removed from <tt class="FILENAME">/etc</tt>: <tt
          class="FILENAME">rc.atm</tt>, <tt
          class="FILENAME">rc.devfs</tt>, <tt
          class="FILENAME">rc.diskless1</tt>, <tt
          class="FILENAME">rc.diskless2</tt>, <tt
          class="FILENAME">rc.i386</tt>, <tt
          class="FILENAME">rc.alpha</tt>, <tt
          class="FILENAME">rc.amd64</tt>, <tt
          class="FILENAME">rc.ia64</tt>, <tt
          class="FILENAME">rc.sparc64</tt>, <tt
          class="FILENAME">rc.isdn</tt>, <tt
          class="FILENAME">rc.network</tt>, <tt
          class="FILENAME">rc.network6</tt>, <tt
          class="FILENAME">rc.pccard</tt>, <tt
          class="FILENAME">rc.serial</tt>, <tt
          class="FILENAME">rc.syscons</tt>, <tt
          class="FILENAME">rc.sysctl</tt>. <a
          href="http://www.FreeBSD.org/cgi/man.cgi?query=mergemaster&amp;sektion=8&amp;manpath=FreeBSD+5.1-release">
          <span class="CITEREFENTRY"><span
          class="REFENTRYTITLE">mergemaster</span>(8)</span></a>,
          when run, will offer to move these files out of the way
          for convenience. More details can be found in <a
          href="http://www.FreeBSD.org/cgi/man.cgi?query=rc.subr&amp;sektion=8&amp;manpath=FreeBSD+5.1-release">
          <span class="CITEREFENTRY"><span
          class="REFENTRYTITLE">rc.subr</span>(8)</span></a>.</p>
        </div>

        <div class="SECT2">
          <hr />

          <h2 class="SECT2"><a id="CONTRIB" name="CONTRIB">2.4
          Contributed Software</a></h2>

          <p>The <b class="APPLICATION">ACPI-CA</b> code has been
          updated from the 20021118 snapshot to the 20030228
          snapshot.</p>

          <p><b class="APPLICATION">awk</b> from Bell Labs has been
          updated to a 14 March 2003 snapshot.</p>

          <p><b class="APPLICATION">BIND</b> has been updated to
          version 8.3.4. [MERGED]</p>

          <p>All of the <b class="APPLICATION">bzip2</b> suite of
          applications is now installed in the base system (in
          particular, <tt class="COMMAND">bzip2recover</tt> is now
          built and installed). [MERGED]</p>

          <p><b class="APPLICATION">CVS</b> has been updated to
          1.11.5. [MERGED]</p>

          <p><b class="APPLICATION">FILE</b> has been updated to
          3.41. [MERGED]</p>

          <p><b class="APPLICATION">GCC</b> has been updated to
          3.2.2 (release version).</p>

          <p>The <b class="APPLICATION">gdtoa</b> library, for
          conversions between strings and floating point, has been
          imported. These sources were dated 24 March 2003.</p>

          <p><b class="APPLICATION">groff</b> (and related
          utilities) have been updated from 1.18.1 to 1.19.</p>

          <p><b class="APPLICATION">IPFilter</b> has been updated
          to 3.4.31. [MERGED]</p>

          <p>The <b class="APPLICATION">ISC DHCP</b> client has
          been updated to 3.0.1RC11. [MERGED]</p>

          <p>The <b class="APPLICATION">ISC DHCP</b> client now
          includes the <a
          href="http://www.FreeBSD.org/cgi/man.cgi?query=omshell&amp;sektion=1&amp;manpath=FreeBSD+5.1-release">
          <span class="CITEREFENTRY"><span
          class="REFENTRYTITLE">omshell</span>(1)</span></a>
          utility and the <a
          href="http://www.FreeBSD.org/cgi/man.cgi?query=dhcpctl&amp;sektion=3&amp;manpath=FreeBSD+5.1-release">
          <span class="CITEREFENTRY"><span
          class="REFENTRYTITLE">dhcpctl</span>(3)</span></a>
          library for run-time control of the client.</p>

          <p><b class="APPLICATION">Kerberos IV</b> support (in the
          form of <b class="APPLICATION">KTH eBones</b>) has been
          removed. Users requiring this functionality can still get
          it from the <tt class="FILENAME">security/krb4</tt> port
          (or package). Kerberos IV compatibility mode for Kerberos
          5 has been removed, and the <tt class="LITERAL">k5<tt
          class="REPLACEABLE"><i>program</i></tt></tt> userland
          utilities have been renamed to <tt class="LITERAL">k<tt
          class="REPLACEABLE"><i>program</i></tt></tt>.</p>

          <p><b class="APPLICATION">Kerberos 5</b> is now built by
          default in <tt class="LITERAL">buildworld</tt>
          operations. Setting <tt
          class="VARNAME">MAKE_KERBEROS5</tt> no longer has any
          effect. Disabling the base system Kerberos 5 now requires
          the <tt class="VARNAME">NO_KERBEROS</tt> Makefile
          variable to be set.</p>

          <p><b class="APPLICATION">libpcap</b> now has support for
          selecting among multiple data link types on an
          interface.</p>

          <p><b class="APPLICATION">lukemftpd</b> (not built or
          installed by default) has been updated to a snapshot from
          22 January 2003.</p>

          <p><b class="APPLICATION">OpenPAM</b> has been updated
          from the ``Citronella'' release to the ``Dianthus''
          release.</p>

          <p><b class="APPLICATION">OpenSSH</b> has been updated to
          3.6.1p1.</p>

          <p><b class="APPLICATION">OpenSSL</b> has been updated to
          release 0.9.7a. Among other features, this release
          includes support for AES and takes advantage of <a
          href="http://www.FreeBSD.org/cgi/man.cgi?query=crypto&amp;sektion=4&amp;manpath=FreeBSD+5.1-release">
          <span class="CITEREFENTRY"><span
          class="REFENTRYTITLE">crypto</span>(4)</span></a>
          devices. [MERGED]</p>

          <p><b class="APPLICATION">sendmail</b> has been updated
          to version 8.12.9. [MERGED]</p>

          <p><a
          href="http://www.FreeBSD.org/cgi/man.cgi?query=tcpdump&amp;sektion=1&amp;manpath=FreeBSD+5.1-release">
          <span class="CITEREFENTRY"><span
          class="REFENTRYTITLE">tcpdump</span>(1)</span></a> has
          been updated to version 3.7.2. [MERGED] It also now
          supports a <tt class="OPTION">-L</tt> flag to list the
          data link types available on an interface and a <tt
          class="OPTION">-y</tt> option to specify the data link
          type to use while capturing packets.</p>

          <p><b class="APPLICATION">texinfo</b> has been updated
          from 4.2 to 4.5.</p>

          <p>The timezone database has been updated from <tt
          class="FILENAME">tzdata2002d</tt> to <tt
          class="FILENAME">tzdata2003a</tt>. [MERGED]</p>
        </div>

        <div class="SECT2">
          <hr />

          <h2 class="SECT2"><a id="PORTS" name="PORTS">2.5
          Ports/Packages Collection Infrastructure</a></h2>

          <p>The one-line <tt class="FILENAME">pkg-comment</tt>
          files have been eliminated from each port skeleton; their
          contents have been moved into each port's <tt
          class="FILENAME">Makefile</tt>. This change reduces the
          disk space and inodes used by the ports tree.
          [MERGED]</p>

          <p>When fetching distfiles for building a port, the <tt
          class="VARNAME">FETCH_REGET</tt> <tt
          class="FILENAME">Makefile</tt> variable can be used to
          specify the number of times to try continuing to fetch a
          distfile if it fails its MD5 checksum. The port
          infrastructure also supports re-fetching interrupted
          distfiles.</p>

          <p><a
          href="http://www.FreeBSD.org/cgi/man.cgi?query=pkg_create&amp;sektion=1&amp;manpath=FreeBSD+5.1-release">
          <span class="CITEREFENTRY"><span
          class="REFENTRYTITLE">pkg_create</span>(1)</span></a> now
          supports a <tt class="OPTION">-C</tt> option, which
          allows packages to register a list of other packages with
          which they conflict. They will refuse to install (via <a
          href="http://www.FreeBSD.org/cgi/man.cgi?query=pkg_add&amp;sektion=1&amp;manpath=FreeBSD+5.1-release">
          <span class="CITEREFENTRY"><span
          class="REFENTRYTITLE">pkg_add</span>(1)</span></a>) if
          one of the listed packages is already present. The <tt
          class="OPTION">-f</tt> flag to <a
          href="http://www.FreeBSD.org/cgi/man.cgi?query=pkg_add&amp;sektion=1&amp;manpath=FreeBSD+5.1-release">
          <span class="CITEREFENTRY"><span
          class="REFENTRYTITLE">pkg_add</span>(1)</span></a>
          overrides this conflict-checking.</p>

          <p><a
          href="http://www.FreeBSD.org/cgi/man.cgi?query=pkg_info&amp;sektion=1&amp;manpath=FreeBSD+5.1-release">
          <span class="CITEREFENTRY"><span
          class="REFENTRYTITLE">pkg_info</span>(1)</span></a> now
          honors the <tt class="VARNAME">BLOCKSIZE</tt> environment
          variable in its output when the <tt
          class="OPTION">-b</tt> flag is given.</p>

          <p><a
          href="http://www.FreeBSD.org/cgi/man.cgi?query=pkg_info&amp;sektion=1&amp;manpath=FreeBSD+5.1-release">
          <span class="CITEREFENTRY"><span
          class="REFENTRYTITLE">pkg_info</span>(1)</span></a> now
          implements a <tt class="OPTION">-Q</tt> option, which is
          similar to the <tt class="OPTION">-q</tt> ``quiet''
          option except that it prefixes the output with the
          package name.</p>
        </div>

        <div class="SECT2">
          <hr />

          <h2 class="SECT2"><a id="RELENG" name="RELENG">2.6
          Release Engineering and Integration</a></h2>

          <p>The supported release of <b
          class="APPLICATION">GNOME</b> has been updated to 2.2.1.
          [MERGED]</p>

          <p>The supported release of <b
          class="APPLICATION">KDE</b> has been updated to 3.1.2.
          [MERGED]</p>

          <p>There is no longer a separate <tt
          class="FILENAME">krb5</tt> distribution. The Kerberos 5
          libraries and utilities have been incorporated into the
          <tt class="FILENAME">crypto</tt> distribution.</p>

          <p><a
          href="http://www.FreeBSD.org/cgi/man.cgi?query=sysinstall&amp;sektion=8&amp;manpath=FreeBSD+5.1-release">
          <span class="CITEREFENTRY"><span
          class="REFENTRYTITLE">sysinstall</span>(8)</span></a>
          once again supports installing individual components of
          <b class="APPLICATION">XFree86</b>. Supporting changes
          (not user-visible) generalize the concept of installing
          parts of distributions as packages.</p>

          <p>The supported release of <b
          class="APPLICATION">XFree86</b> has been updated to
          4.3.0. [MERGED]</p>

          <p>Several upgrade mechanisms designed to permit major
          version upgrades from FreeBSD 2.<tt
          class="REPLACEABLE"><i>X</i></tt> to 3.<tt
          class="REPLACEABLE"><i>X</i></tt> and from FreeBSD 3.<tt
          class="REPLACEABLE"><i>X</i></tt> to 4.<tt
          class="REPLACEABLE"><i>X</i></tt> have been removed.</p>
        </div>

        <div class="SECT2">
          <hr />

          <h2 class="SECT2"><a id="DOC" name="DOC">2.7
          Documentation</a></h2>

          <p>The following new articles have been added to the
          documentation set: ``FreeBSD From Scratch'', ``The
          Roadmap for 5-STABLE''.</p>

          <p>A new Danish (<tt
          class="FILENAME">da_DK.ISO8859-1</tt>) translation
          project has been started.</p>
        </div>
      </div>

      <div class="SECT1">
        <hr />

        <h1 class="SECT1"><a id="UPGRADE" name="UPGRADE">3
        Upgrading from previous releases of FreeBSD</a></h1>

        <p>Users with existing FreeBSD systems are <span
        class="emphasis"><i class="EMPHASIS">highly</i></span>
        encouraged to read the ``Early Adopter's Guide to FreeBSD
        5.1-RELEASE''. This document generally has the filename <tt
        class="FILENAME">EARLY.TXT</tt> on the distribution media,
        or any other place that the release notes can be found. It
        offers some notes on upgrading, but more importantly, also
        discusses some of the relative merits of upgrading to
        FreeBSD 5.<tt class="REPLACEABLE"><i>X</i></tt> versus
        running FreeBSD 4.<tt
        class="REPLACEABLE"><i>X</i></tt>.</p>

        <div class="IMPORTANT">
          <blockquote class="IMPORTANT">
            <p><b>Important:</b> Upgrading FreeBSD should, of
            course, only be attempted after backing up <span
            class="emphasis"><i class="EMPHASIS">all</i></span>
            data and configuration files.</p>
          </blockquote>
        </div>
      </div>
    </div>
    <hr />

    <p align="center"><small>This file, and other release-related
    documents, can be downloaded from <a
    href="ftp://ftp.FreeBSD.org/">ftp://ftp.FreeBSD.org/</a>.</small></p>

    <p align="center"><small>For questions about FreeBSD, read the
    <a href="http://www.FreeBSD.org/docs.html">documentation</a>
    before contacting &#60;<a
    href="mailto:questions@FreeBSD.org">questions@FreeBSD.org</a>&#62;.</small></p>

    <p align="center"><small><small>All users of FreeBSD 5-CURRENT
    should subscribe to the &#60;<a
    href="mailto:current@FreeBSD.org">current@FreeBSD.org</a>&#62;
    mailing list.</small></small></p>

    <p align="center">For questions about this documentation,
    e-mail &#60;<a
    href="mailto:doc@FreeBSD.org">doc@FreeBSD.org</a>&#62;.</p>
    <br />
    <br />
++++


